<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
<meta name="viewport" content="width=device-width">
<meta name="theme-color" content="#222">
<meta name="generator" content="Hexo 5.4.0">
<meta name="google-site-verification" content="df-PGWZFHMTbL8pxwFsvUjp3s06o3HKyNVQ1IEjc4CI" />
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-XBRXD1X7E3"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-XBRXD1X7E3');
</script>


  <link rel="apple-touch-icon" sizes="180x180" href="/images/apple-touch-icon-next.png">
  <link rel="icon" type="image/png" sizes="32x32" href="/images/favicon.png">
  <link rel="icon" type="image/png" sizes="16x16" href="/images/favicon.png">
  <link rel="mask-icon" href="/images/logo.svg" color="#222">

<link rel="stylesheet" href="/css/main.css">



<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free@5.15.4/css/all.min.css" integrity="sha256-mUZM63G8m73Mcidfrv5E+Y61y7a12O5mW4ezU3bxqW4=" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/animate.css@3.1.1/animate.min.css" integrity="sha256-PR7ttpcvz8qrF57fur/yAx1qXMFJeJFiA6pSzWi0OIE=" crossorigin="anonymous">

<script class="next-config" data-name="main" type="application/json">{"hostname":"kyllsccs.github.io","root":"/","images":"/images","scheme":"Mist","darkmode":false,"version":"8.7.1","exturl":false,"sidebar":{"position":"left","Muse | Mist":320,"display":"always","padding":18,"offset":12},"copycode":true,"bookmark":{"enable":false,"color":"#222","save":"auto"},"mediumzoom":false,"lazyload":false,"pangu":false,"comments":{"style":"tabs","active":null,"storage":true,"lazyload":false,"nav":null},"stickytabs":false,"motion":{"enable":true,"async":false,"transition":{"post_block":"fadeIn","post_header":"fadeInDown","post_body":"fadeInDown","coll_header":"fadeInLeft","sidebar":"fadeInUp"}},"prism":false,"i18n":{"placeholder":"Searching...","empty":"We didn't find any results for the search: ${query}","hits_time":"${hits} results found in ${time} ms","hits":"${hits} results found"},"path":"/search.xml","localsearch":{"enable":true,"trigger":"auto","top_n_per_article":1,"unescape":false,"preload":false}}</script><script src="/js/config.js"></script>
<meta name="description" content="Rust 靜態語言, 透過自身的 Ownership System 去管理記憶體,有別於其他語言有 GC (Garbage Collector) 的方式.">
<meta property="og:type" content="article">
<meta property="og:title" content="Rust Note(3)_Variables I">
<meta property="og:url" content="https://kyllsccs.github.io/2021/10/20/20211020/index.html">
<meta property="og:site_name" content="Kylls KB NOTEs">
<meta property="og:description" content="Rust 靜態語言, 透過自身的 Ownership System 去管理記憶體,有別於其他語言有 GC (Garbage Collector) 的方式.">
<meta property="og:locale" content="en_US">
<meta property="article:published_time" content="2021-10-19T23:29:46.000Z">
<meta property="article:modified_time" content="2021-10-20T01:55:30.080Z">
<meta property="article:author" content="Kylls Bellies_KB">
<meta property="article:tag" content="Rust">
<meta name="twitter:card" content="summary">


<link rel="canonical" href="https://kyllsccs.github.io/2021/10/20/20211020/">



<script class="next-config" data-name="page" type="application/json">{"sidebar":"","isHome":false,"isPost":true,"lang":"en","comments":true,"permalink":"https://kyllsccs.github.io/2021/10/20/20211020/","path":"2021/10/20/20211020/","title":"Rust Note(3)_Variables I"}</script>

<script class="next-config" data-name="calendar" type="application/json">""</script>
<title>Rust Note(3)_Variables I | Kylls KB NOTEs</title>
  




  <noscript>
    <link rel="stylesheet" href="/css/noscript.css">
  </noscript>
</head>

<body itemscope itemtype="http://schema.org/WebPage" class="use-motion">
  <div class="headband"></div>

  <main class="main">
    <header class="header" itemscope itemtype="http://schema.org/WPHeader">
      <div class="header-inner"><div class="site-brand-container">
  <div class="site-nav-toggle">
    <div class="toggle" aria-label="Toggle navigation bar" role="button">
        <span class="toggle-line"></span>
        <span class="toggle-line"></span>
        <span class="toggle-line"></span>
    </div>
  </div>

  <div class="site-meta">

    <a href="/" class="brand" rel="start">
      <i class="logo-line"></i>
      <h1 class="site-title">Kylls KB NOTEs</h1>
      <i class="logo-line"></i>
    </a>
      <p class="site-subtitle" itemprop="description">Go a_head</p>
  </div>

  <div class="site-nav-right">
    <div class="toggle popup-trigger">
        <i class="fa fa-search fa-fw fa-lg"></i>
    </div>
  </div>
</div>



<nav class="site-nav">
  <ul class="main-menu menu">
        <li class="menu-item menu-item-home"><a href="/" rel="section"><i class="fa fa-home fa-fw"></i>Home</a></li>
        <li class="menu-item menu-item-about"><a href="/about/" rel="section"><i class="fa fa-user fa-fw"></i>About</a></li>
        <li class="menu-item menu-item-tags"><a href="/tags/" rel="section"><i class="fa fa-tags fa-fw"></i>Tags</a></li>
        <li class="menu-item menu-item-categories"><a href="/categories/" rel="section"><i class="fa fa-th fa-fw"></i>Categories</a></li>
        <li class="menu-item menu-item-archives"><a href="/archives/" rel="section"><i class="fa fa-archive fa-fw"></i>Archives</a></li>
      <li class="menu-item menu-item-search">
        <a role="button" class="popup-trigger"><i class="fa fa-search fa-fw"></i>Search
        </a>
      </li>
  </ul>
</nav>



  <div class="search-pop-overlay">
    <div class="popup search-popup"><div class="search-header">
  <span class="search-icon">
    <i class="fa fa-search"></i>
  </span>
  <div class="search-input-container">
    <input autocomplete="off" autocapitalize="off" maxlength="80"
           placeholder="Searching..." spellcheck="false"
           type="search" class="search-input">
  </div>
  <span class="popup-btn-close" role="button">
    <i class="fa fa-times-circle"></i>
  </span>
</div>
<div class="search-result-container no-result">
  <div class="search-result-icon">
    <i class="fa fa-spinner fa-pulse fa-5x"></i>
  </div>
</div>

    </div>
  </div>

</div>
        
  
  <div class="toggle sidebar-toggle" role="button">
    <span class="toggle-line"></span>
    <span class="toggle-line"></span>
    <span class="toggle-line"></span>
  </div>

  <aside class="sidebar">

    <div class="sidebar-inner sidebar-nav-active sidebar-toc-active">
      <ul class="sidebar-nav">
        <li class="sidebar-nav-toc">
          Table of Contents
        </li>
        <li class="sidebar-nav-overview">
          Overview
        </li>
      </ul>

      <div class="sidebar-panel-container">
        <!--noindex-->
        <div class="post-toc-wrap sidebar-panel">
            <div class="post-toc animated"><ol class="nav"><li class="nav-item nav-level-2"><a class="nav-link" href="#1-Setting-variables-%E8%AE%8A%E6%95%B8%E8%B3%A6%E5%80%BC"><span class="nav-number">1.</span> <span class="nav-text">1. Setting variables 變數賦值</span></a></li><li class="nav-item nav-level-2"><a class="nav-link" href="#2-%E8%AE%8A%E6%95%B8%E9%87%8D%E8%A4%87%E8%B3%A6%E5%80%BC"><span class="nav-number">2.</span> <span class="nav-text">2. 變數重複賦值</span></a></li><li class="nav-item nav-level-2"><a class="nav-link" href="#3-%E8%AE%8A%E6%95%B8%E9%87%8D%E6%96%B0%E8%B3%A6%E5%80%BC"><span class="nav-number">3.</span> <span class="nav-text">3. 變數重新賦值</span></a></li><li class="nav-item nav-level-2"><a class="nav-link" href="#4-%E5%B8%B8%E6%95%B8-%E4%B8%8D%E5%8F%AF%E8%AE%8A-const"><span class="nav-number">4.</span> <span class="nav-text">4. 常數 (不可變) const</span></a></li><li class="nav-item nav-level-2"><a class="nav-link" href="#5-%E9%87%8D%E9%BB%9E%E6%95%B4%E7%90%86"><span class="nav-number">5.</span> <span class="nav-text">5. 重點整理</span></a></li></ol></div>
        </div>
        <!--/noindex-->

        <div class="site-overview-wrap sidebar-panel">
          <div class="site-author site-overview-item animated" itemprop="author" itemscope itemtype="http://schema.org/Person">
    <img class="site-author-image" itemprop="image" alt="Kylls Bellies_KB"
      src="/images/avatar.jpg">
  <p class="site-author-name" itemprop="name">Kylls Bellies_KB</p>
  <div class="site-description" itemprop="description">Miss understanding</div>
</div>
<div class="site-state-wrap site-overview-item animated">
  <nav class="site-state">
      <div class="site-state-item site-state-posts">
        <a href="/archives/">
          <span class="site-state-item-count">12</span>
          <span class="site-state-item-name">posts</span>
        </a>
      </div>
      <div class="site-state-item site-state-categories">
          <a href="/categories/">
        <span class="site-state-item-count">3</span>
        <span class="site-state-item-name">categories</span></a>
      </div>
      <div class="site-state-item site-state-tags">
          <a href="/tags/">
        <span class="site-state-item-count">3</span>
        <span class="site-state-item-name">tags</span></a>
      </div>
  </nav>
</div>
  <div class="links-of-author site-overview-item animated">
      <span class="links-of-author-item">
        <a href="https://github.com/kyllsccs" title="GitHub → https:&#x2F;&#x2F;github.com&#x2F;kyllsccs" rel="noopener" target="_blank"><i class="fab fa-github fa-fw"></i>GitHub</a>
      </span>
      <span class="links-of-author-item">
        <a href="mailto:kylls.ccs@gmail.com" title="E-Mail → mailto:kylls.ccs@gmail.com" rel="noopener" target="_blank"><i class="fa fa-envelope fa-fw"></i>E-Mail</a>
      </span>
  </div>



        </div>
      </div>
    </div>
  </aside>
  <div class="sidebar-dimmer"></div>


    </header>

    
  <div class="back-to-top" role="button" aria-label="Back to top">
    <i class="fa fa-arrow-up"></i>
    <span>0%</span>
  </div>

<noscript>
  <div class="noscript-warning">Theme NexT works best with JavaScript enabled</div>
</noscript>


    <div class="main-inner post posts-expand">


  


<div class="post-block">
  
  

  <article itemscope itemtype="http://schema.org/Article" class="post-content" lang="en">
    <link itemprop="mainEntityOfPage" href="https://kyllsccs.github.io/2021/10/20/20211020/">

    <span hidden itemprop="author" itemscope itemtype="http://schema.org/Person">
      <meta itemprop="image" content="/images/avatar.jpg">
      <meta itemprop="name" content="Kylls Bellies_KB">
      <meta itemprop="description" content="Miss understanding">
    </span>

    <span hidden itemprop="publisher" itemscope itemtype="http://schema.org/Organization">
      <meta itemprop="name" content="Kylls KB NOTEs">
    </span>
      <header class="post-header">
        <h1 class="post-title" itemprop="name headline">
          Rust Note(3)_Variables I
        </h1>

        <div class="post-meta-container">
          <div class="post-meta">
    <span class="post-meta-item">
      <span class="post-meta-item-icon">
        <i class="far fa-calendar"></i>
      </span>
      <span class="post-meta-item-text">Posted on</span>
      

      <time title="Created: 2021-10-20 07:29:46 / Modified: 09:55:30" itemprop="dateCreated datePublished" datetime="2021-10-20T07:29:46+08:00">2021-10-20</time>
    </span>
    <span class="post-meta-item">
      <span class="post-meta-item-icon">
        <i class="far fa-folder"></i>
      </span>
      <span class="post-meta-item-text">In</span>
        <span itemprop="about" itemscope itemtype="http://schema.org/Thing">
          <a href="/categories/Rust/" itemprop="url" rel="index"><span itemprop="name">Rust</span></a>
        </span>
    </span>

  
    <span class="post-meta-item" title="Views" id="busuanzi_container_page_pv">
      <span class="post-meta-item-icon">
        <i class="far fa-eye"></i>
      </span>
      <span class="post-meta-item-text">Views: </span>
      <span id="busuanzi_value_page_pv"></span>
    </span>
    <span class="post-meta-break"></span>
    <span class="post-meta-item" title="Symbols count in article">
      <span class="post-meta-item-icon">
        <i class="far fa-file-word"></i>
      </span>
      <span class="post-meta-item-text">Symbols count in article: </span>
      <span>4.3k</span>
    </span>
    <span class="post-meta-item" title="Reading time">
      <span class="post-meta-item-icon">
        <i class="far fa-clock"></i>
      </span>
      <span class="post-meta-item-text">Reading time &asymp;</span>
      <span>4 mins.</span>
    </span>
</div>

        </div>
      </header>

    
    
    
    <div class="post-body" itemprop="articleBody">
        <blockquote>
<p>Rust 靜態語言, 透過自身的 Ownership System 去管理記憶體,<br>有別於其他語言有 GC (Garbage Collector) 的方式.</p>
</blockquote>
<span id="more"></span>

<hr>
<h2 id="1-Setting-variables-變數賦值"><a href="#1-Setting-variables-變數賦值" class="headerlink" title="1. Setting variables 變數賦值"></a>1. Setting variables 變數賦值</h2><hr>
<p>使用<code>let</code>關鍵字, 如下:</p>
<p><code>Sample Code 1-1 變數賦值 let</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">let</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定變數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y) <span class="comment">// 印出y</span></span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output:</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">$ cargo run</span><br><span class="line">   Compiling rust_project v0.1.0 (D:\000_git_repo_projects\rust_project)</span><br><span class="line">    Finished dev [unoptimized + debuginfo] target(s) <span class="keyword">in</span> 0.50s</span><br><span class="line">     Running `target\debug\rust_project.exe`</span><br><span class="line">The value of y is 10</span><br></pre></td></tr></table></figure>

</span>

<h2 id="2-變數重複賦值"><a href="#2-變數重複賦值" class="headerlink" title="2. 變數重複賦值"></a>2. 變數重複賦值</h2><hr>
<blockquote>
<p>Compiler 直接拋出錯誤, <code>不可重複</code>對<code>不可變(不可改變值的變數)的變數</code>賦值<br>範例 1-2</p>
</blockquote>
<p><code>Sample Code 2-1 重複賦值, compiler報錯</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">let</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定變數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y) <span class="comment">// 印出y</span></span><br><span class="line">    y = <span class="number">20</span>;</span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The new value of y is &#123;&#125;&quot;</span>, y)</span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br></pre></td><td class="code"><pre><span class="line">error[E0384]: cannot assign twice to immutable variable `y`</span><br><span class="line"> --&gt; src\main.rs:4:5</span><br><span class="line">  |</span><br><span class="line">2 |     <span class="built_in">let</span> y : i64 = 10; // 設定變數y型別為整數型64位元, 值為10</span><br><span class="line">  |         -</span><br><span class="line">  |         |</span><br><span class="line">  |         first assignment to `y`</span><br><span class="line">  |         <span class="built_in">help</span>: consider making this binding mutable: `mut y`</span><br><span class="line">3 |     println!(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y); // 印出y</span><br><span class="line">4 |     y = 20;</span><br><span class="line">  |     ^^^^^^ cannot assign twice to immutable variable</span><br><span class="line"></span><br><span class="line">For more information about this error, try `rustc --explain E0384`.</span><br><span class="line">error: could not compile `rust_project` due to previous error</span><br></pre></td></tr></table></figure>

<blockquote>
<p>看 terminal 輸出的訊息, 可把變數 y 的型態設定為 <code>mut (mutable)</code> 可變</p>
</blockquote>
<p><code>Sample Code 2-2 指定為可變變數 mut</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">let</span> <span class="keyword">mut</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定變數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y</span></span><br><span class="line">    y = <span class="number">20</span>;</span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The new value of y is &#123;&#125;&quot;</span>, y);</span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line">$ cargo run</span><br><span class="line">   Compiling rust_project v0.1.0 (D:\000_git_repo_projects\rust_project)</span><br><span class="line">    Finished dev [unoptimized + debuginfo] target(s) <span class="keyword">in</span> 0.37s</span><br><span class="line">     Running `target\debug\rust_project.exe`</span><br><span class="line">The value of y is 10</span><br><span class="line">The new value of y is 20</span><br></pre></td></tr></table></figure>

<blockquote>
<p>告訴 compiler y 這是一個<code>可改變</code>的變數, 這樣就沒問題了.</p>
</blockquote>
<h2 id="3-變數重新賦值"><a href="#3-變數重新賦值" class="headerlink" title="3. 變數重新賦值"></a>3. 變數重新賦值</h2><p><code>重新賦值</code> 跟 <code>重複賦值</code> 不一樣定義</p>
<blockquote>
<p>第一次變數賦值 : 把變數值存到 <code>heap 堆</code> 裡面<br>第二次重新賦值 : 重新覆蓋在 <code>heap 堆</code> 裡面的值</p>
</blockquote>
<p><code>Sample Code 3-1 重新賦值, 比對上段 重複復職</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">let</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定變數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y = 10</span></span><br><span class="line">    <span class="keyword">let</span> y : <span class="built_in">i64</span> = <span class="number">20</span>; <span class="comment">// 重新賦值, 覆蓋過heap堆上的值, 重新取代</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The new value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y = 20</span></span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">$ cargo run</span><br><span class="line">    Finished dev [unoptimized + debuginfo] target(s) <span class="keyword">in</span> 0.00s</span><br><span class="line">     Running `target\debug\rust_project.exe`</span><br><span class="line">The value of y is 10</span><br><span class="line">The new value of y is 20</span><br></pre></td></tr></table></figure>

<blockquote>
<p>compiler 沒有報錯, 因為 y <code>重新</code> 被賦值</p>
</blockquote>
<hr>
<blockquote>
<p>此時如果指定 y 為 <code>mut</code> 型態, compiler 就會出現<code>善意提醒</code></p>
</blockquote>
<p><code>Sample Code 3-2 提醒mut為非必要</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">let</span> <span class="keyword">mut</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定變數y型別為可變整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y = 10</span></span><br><span class="line">    <span class="keyword">let</span> y : <span class="built_in">i64</span> = <span class="number">20</span>; <span class="comment">// 重新賦值, 覆蓋過heap堆上的值, 重新取代</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The new value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y = 20</span></span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br></pre></td><td class="code"><pre><span class="line">warning: variable does not need to be mutable</span><br><span class="line"> --&gt; src\main.rs:2:9</span><br><span class="line">  |</span><br><span class="line">2 |     <span class="built_in">let</span> mut y : i64 = 10; // 設定變數y型別為可變整數型64位元, 值為10</span><br><span class="line">  |         ----^</span><br><span class="line">  |         |</span><br><span class="line">  |         <span class="built_in">help</span>: remove this `mut`</span><br><span class="line">  |</span><br><span class="line">  = note: `<span class="comment">#[warn(unused_mut)]` on by default</span></span><br><span class="line"></span><br><span class="line">warning: `rust_project` (bin <span class="string">&quot;rust_project&quot;</span>) generated 1 warning</span><br><span class="line">    Finished dev [unoptimized + debuginfo] target(s) <span class="keyword">in</span> 0.39s</span><br><span class="line">     Running `target\debug\rust_project.exe`</span><br><span class="line">The value of y is 10</span><br><span class="line">The new value of y is 20</span><br></pre></td></tr></table></figure>

<blockquote>
<p>Compiler 一樣打印出值, 但是會提醒, <code>mut</code> 是不必要的.</p>
</blockquote>
<h2 id="4-常數-不可變-const"><a href="#4-常數-不可變-const" class="headerlink" title="4. 常數 (不可變) const"></a>4. 常數 (不可變) const</h2><hr>
<blockquote>
<p>常數 : 意味著 不可變的, 賦值後, 不可做任何修改<br>宣告常數使用關鍵字 : <code>const &lt;CONST_NAME&gt;</code> : <CONST_NAME> 必須要大寫</p>
</blockquote>
<p><code>Sample Code 4-1 : 提醒大寫</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">const</span> y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定常數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, y); <span class="comment">// 印出y = 10</span></span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br></pre></td><td class="code"><pre><span class="line">   Compiling rust_project v0.1.0 (D:\000_git_repo_projects\rust_project)</span><br><span class="line">warning: constant `y` should have an upper <span class="keyword">case</span> name</span><br><span class="line"> --&gt; src\main.rs:2:11</span><br><span class="line">  |</span><br><span class="line">2 |     const y : i64 = 10; // 設定變數y型別為可變整數型64位元, 值為10</span><br><span class="line">  |           ^ <span class="built_in">help</span>: convert the identifier to upper <span class="keyword">case</span> (notice the capitalization): `Y`</span><br><span class="line">  |</span><br><span class="line">  = note: `<span class="comment">#[warn(non_upper_case_globals)]` on by default</span></span><br><span class="line"></span><br><span class="line">warning: `rust_project` (bin <span class="string">&quot;rust_project&quot;</span>) generated 1 warning</span><br><span class="line">    Finished dev [unoptimized + debuginfo] target(s) <span class="keyword">in</span> 0.39s</span><br><span class="line">     Running `target\debug\rust_project.exe`</span><br><span class="line">The value of y is 10</span><br></pre></td></tr></table></figure>

<blockquote>
<p>Compiler 提醒需要大寫, 但仍正常編譯</p>
</blockquote>
<p>對常數重新賦值, compiler 報錯</p>
<p><code>Sample Code 對常數重新賦值, 報錯</code></p>
<figure class="highlight rust"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line"><span class="function"><span class="keyword">fn</span> <span class="title">main</span></span>() &#123;</span><br><span class="line">    <span class="keyword">const</span> Y : <span class="built_in">i64</span> = <span class="number">10</span>; <span class="comment">// 設定常數y型別為整數型64位元, 值為10</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, Y); <span class="comment">// 印出y = 10</span></span><br><span class="line">    <span class="keyword">let</span> Y : <span class="built_in">i64</span> = <span class="number">20</span>; <span class="comment">// 重新賦值 報錯</span></span><br><span class="line">    <span class="built_in">println!</span>(<span class="string">&quot;&#123;&#125;&quot;</span>, Y)</span><br><span class="line">&#125;</span><br></pre></td></tr></table></figure>

<p><code>Output</code></p>
<figure class="highlight bash"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br></pre></td><td class="code"><pre><span class="line">error[E0005]: refutable pattern <span class="keyword">in</span> <span class="built_in">local</span> binding: `i64::MIN..=9_i64` and `11_i64..=i64::MAX` not covered</span><br><span class="line"> --&gt; src\main.rs:4:9</span><br><span class="line">  |</span><br><span class="line">2 |     const Y : i64 = 10; // 設定常數y型別為整數型64位元, 值為10</span><br><span class="line">  |     ------------------- constant defined here</span><br><span class="line">3 |     println!(<span class="string">&quot;The value of y is &#123;&#125;&quot;</span>, Y); // 印出y = 10</span><br><span class="line">4 |     <span class="built_in">let</span> Y : i64 = 20;</span><br><span class="line">  |         ^</span><br><span class="line">  |         |</span><br><span class="line">  |         interpreted as a constant pattern, not a new variable</span><br><span class="line">  |         <span class="built_in">help</span>: introduce a variable instead: `y_var`</span><br><span class="line">  |</span><br><span class="line">  = note: the matched value is of <span class="built_in">type</span> `i64`</span><br><span class="line"></span><br><span class="line">For more information about this error, try `rustc --explain E0005`.</span><br><span class="line">error: could not compile `rust_project` due to previous error</span><br></pre></td></tr></table></figure>

<blockquote>
<p><strong>const 常數</strong> 為不可變動的值</p>
</blockquote>
</br>

<h2 id="5-重點整理"><a href="#5-重點整理" class="headerlink" title="5. 重點整理"></a>5. 重點整理</h2><hr>
<ul>
<li>宣告設定變數<ul>
<li>  let : 一般變數</li>
<li>  const : 常數</li>
</ul>
</li>
<li>變數可變<ul>
<li>  mut : 可變, 不套用常數(const)</li>
</ul>
</li>
</ul>
<p>Rust Note_20211020</p>

    </div>

    
    
    

    <footer class="post-footer">
          <div class="post-tags">
              <a href="/tags/Rust/" rel="tag"># Rust</a>
          </div>

        

          <div class="post-nav">
            <div class="post-nav-item">
                <a href="/2021/10/18/20211018/" rel="prev" title="SQL進階篇_MSSQL [双迴圈]">
                  <i class="fa fa-chevron-left"></i> SQL進階篇_MSSQL [双迴圈]
                </a>
            </div>
            <div class="post-nav-item">
                <a href="/2021/10/20/20211016/" rel="next" title="Rust Note(1)_Data Type I">
                  Rust Note(1)_Data Type I <i class="fa fa-chevron-right"></i>
                </a>
            </div>
          </div>
    </footer>
  </article>
</div>






</div>
  </main>

  <footer class="footer">
    <div class="footer-inner">


<div class="copyright">
  &copy; 
  <span itemprop="copyrightYear">2021</span>
  <span class="with-love">
    <i class="fa fa-heart"></i>
  </span>
  <span class="author" itemprop="copyrightHolder">kyllsccs@github</span>
</div>
<div class="wordcount">
  <span class="post-meta-item">
    <span class="post-meta-item-icon">
      <i class="fa fa-chart-line"></i>
    </span>
      <span>Symbols count total: </span>
    <span title="Symbols count total">20k</span>
  </span>
  <span class="post-meta-item">
    <span class="post-meta-item-icon">
      <i class="fa fa-coffee"></i>
    </span>
      <span>Reading time total &asymp;</span>
    <span title="Reading time total">18 mins.</span>
  </span>
</div>
<div class="busuanzi-count">
    <span class="post-meta-item" id="busuanzi_container_site_uv">
      <span class="post-meta-item-icon">
        <i class="fa fa-user"></i>
      </span>
      <span class="site-uv" title="Total Visitors">
        <span id="busuanzi_value_site_uv"></span>
      </span>
    </span>
    <span class="post-meta-item" id="busuanzi_container_site_pv">
      <span class="post-meta-item-icon">
        <i class="fa fa-eye"></i>
      </span>
      <span class="site-pv" title="Total Views">
        <span id="busuanzi_value_site_pv"></span>
      </span>
    </span>
</div>

    </div>
  </footer>

  
  <script src="https://cdn.jsdelivr.net/npm/animejs@3.2.1/lib/anime.min.js" integrity="sha256-XL2inqUJaslATFnHdJOi9GfQ60on8Wx1C2H8DYiN1xY=" crossorigin="anonymous"></script>
<script src="/js/comments.js"></script><script src="/js/utils.js"></script><script src="/js/motion.js"></script><script src="/js/schemes/muse.js"></script><script src="/js/next-boot.js"></script>

  
<script src="/js/third-party/search/local-search.js"></script>





  
  <script async src="https://busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script>





</body>
</html>
